Subject: Re: 2.6.37 regression: adding main interface to a bridge breaks vlan interface RX

From: Nicolas de Pesloüan<[email-masked]>
Date: Mon, 07 Feb 2011 13:09:36 +0100

Le 06/02/2011 20:37, chriss a écrit :
> Jesse Gross<jesse<at>  nicira.com>  writes:
>
>>
>> You should either attached a bridge to a vlan device or stack a vlan
>> device on the bridge port depending on what you are trying to achieve.
>>
>> The bridge handler takes all packets of the device that it is attached
>> to, so having a vlan also attached to the same device will not work.
>> You may get different results on older kernels depending on what NIC
>> you were using but that was a bug.
>> --
>> To unsubscribe from this list: send the line "unsubscribe netdev" in
>> the body of a message to majordomo<at>  vger.kernel.org
>> More majordomo info at  http://vger.kernel.org/majordomo-info.html
>>
>>
>
>
> Hi and thanks for your reply
>
> I tried that.
>
> I had under 2.6.36.3 following combination:
>
> eth1 in br0 ->  all traffic without vlan id
> eth1.3 ->  traffic with vlan 3
>
> with 2.6.37 i should do the following
> eth1 in br0 ->  traffic w/o vlans
> and br0.3 ->  traffic with vlan id 3
>
> But still there is no rx for vlan 3.
> Any suggestions? Or am i missing something?

I think you should have a look at ebtables command, in particular, the BROUTING chain of broute 
table. If this chain ask the packet to be dropped, then bridge will ignore it and give a chance to 
the upper layer to use it. Upper layer might be IP, or in your particular setup, VLAN.

HTH,

	Nicolas.

In order for eth1.3 to receive the traffic with VLANID=3, while having the bridge get everything 
else, you should add an entry to the